CREATE PROCEDURE RQDELETE_PROJECT (projId INTEGER) 
LANGUAGE SQL
BEGIN
   DECLARE SQLCODE INTEGER DEFAULT 0;
   DECLARE retcode INTEGER DEFAULT 0;
   DECLARE sql_txt VARCHAR(200);
   DECLARE sql_call VARCHAR(200);

   DECLARE CONTINUE HANDLER FOR SQLEXCEPTION SET retcode = SQLCODE;
   DECLARE CONTINUE HANDLER FOR SQLWARNING SET retcode = SQLCODE; 
   DECLARE CONTINUE HANDLER FOR NOT FOUND SET retcode = SQLCODE; 

   SET sql_call = 'CALL RQDROP_VIEWS(?)';
   PREPARE STMT FROM sql_call;

   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQDOCUMENTTYPEUSERS WHERE PROJECTID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQREQUIREMENTTYPEUSERS WHERE PROJECTID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQUSERDEFINEDFIELDUSERS WHERE PROJECTID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQUSERDEFINEDLISTITEMUSERS WHERE PROJECTID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQUSERS WHERE GROUPID IN '||
                 '(SELECT USERGROUPID FROM RQPROJECTUSERS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQUSERGROUPS WHERE ID IN '||
                 '(SELECT USERGROUPID FROM RQPROJECTUSERS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQDISCUSSIONS WHERE ROOTID IN '||
                 '(SELECT DISCUSSIONID FROM RQPROJECTDISCUSSIONS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQOVERFLOWHISTORY WHERE OVERFLOWTYPE = 2 AND OVERFLOWID IN '||
                 '(SELECT DOCUMENTID FROM RQPROJECTDOCUMENTS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQDOCUMENTS WHERE ID IN '||
                 '(SELECT DOCUMENTID FROM RQPROJECTDOCUMENTS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQDOCUMENTTYPES WHERE ID IN '||
                 '(SELECT DOCUMENTTYPEID FROM RQPROJECTDOCUMENTTYPES WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQTORELATIONSHIPS WHERE EXTERNALPROJECTID = 0 AND REQUIREMENTID IN '||
                 '(SELECT REQUIREMENTID FROM RQPROJECTREQUIREMENTS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQTORELATIONSHIPS WHERE EXTERNALPROJECTTOID = 0 AND TOID IN '||
                 '(SELECT REQUIREMENTID FROM RQPROJECTREQUIREMENTS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQTORELATIONSHIPS WHERE EXTERNALPROJECTID = ? '||
                 'OR EXTERNALPROJECTTOID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId, projId;

   SET sql_txt = 'DELETE FROM RQOVERFLOWHISTORY WHERE OVERFLOWTYPE = 1 AND OVERFLOWID IN '||
                 '(SELECT REQUIREMENTID FROM RQPROJECTREQUIREMENTS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQREQUIREMENTS WHERE ID IN '||
                 '(SELECT REQUIREMENTID FROM RQPROJECTREQUIREMENTS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQUSERDEFINEDFIELDS WHERE ID IN '||
                 '(SELECT USERDEFINEDFIELDID FROM RQREQUIREMENTTYPEFIELDS F, RQPROJECTREQUIREMENTTYPES P '||
                 'WHERE F.REQUIREMENTTYPEID = P.REQUIREMENTTYPEID AND PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQREQUIREMENTTYPES WHERE ID IN '||
                 '(SELECT REQUIREMENTTYPEID FROM RQPROJECTREQUIREMENTTYPES WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQQUERYDEFINITIONS WHERE ID IN '||
                 '(SELECT SECONDARYQUERYID FROM RQVIEWS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQQUERYDEFINITIONS WHERE ID IN '||
                 '(SELECT QUERYID FROM RQVIEWS WHERE PROJECTID = ?)';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQOVERFLOWHISTORY WHERE OVERFLOWTYPE = 3 AND OVERFLOWID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQPACKAGES WHERE PROJECTID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQEXTERNALPROJECTS WHERE ID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;
 
   SET sql_txt = 'UPDATE RQPROJECTS SET versionreason = ''!DELETING!'' WHERE ID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   SET sql_txt = 'DELETE FROM RQPROJECTS WHERE ID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   COMMIT;

   SET sql_txt = 'DELETE FROM RQPROJECTS WHERE ID = ?';
   PREPARE STMT FROM sql_txt;
   EXECUTE STMT USING projId;

   DELETE FROM RQEXTERNALPROJECTS
   WHERE ID NOT IN
      (SELECT EXTERNALPROJECTID FROM RQPROJECTEXTERNALPROJECTS);

   COMMIT;
END
@